use crate::cell::CellView;
#[cfg(feature = "embassy-sync")]
use embassy_sync::blocking_mutex::raw::RawMutex;
#[cfg(feature = "embassy-sync")]
use embassy_sync::pubsub::PubSubChannel;
pub use physical::transducer::input::*;

#[cfg(feature = "embassy-sync")]
pub struct PublishInput<
    T: Copy,
    MutexT: RawMutex,
    const CAPACITY: usize,
    const NUM_SUBS: usize,
    const NUM_PUBS: usize,
> {
    channel: PubSubChannel<MutexT, T, CAPACITY, NUM_SUBS, NUM_PUBS>,
}

#[cfg(feature = "embassy-sync")]
pub struct StatefulPublishInput<
    'a,
    T: Copy,
    MutexT: RawMutex,
    const CAPACITY: usize,
    const NUM_SUBS: usize,
    const NUM_PUBS: usize,
> {
    pub state_cell: CellView<'a, T>,
    channel: PubSubChannel<MutexT, T, CAPACITY, NUM_SUBS, NUM_PUBS>,
}
